#!/usr/bin/php
<?
chdir(dirname(__FILE__));
require_once('../nmail/include/global.php');
require_once("include/mail_lib.php");
require_once('include/admin_lib.php');
require_once("include/file.php");


// 󿡼 .
if ($_SERVER['DOCUMENT_ROOT'])
{
	die("Access Denied");	
}	// if()


// set
set_time_limit(0);

echo "[Nmail]Ÿ̽   ġ Դϴ...\n\n";
echo "  ȳ) ۾ ̹ ġ κ ڵ ѾǷ, ߺϴ   ʽϴ.\n\n";

if ($G_SYS[DB] == 'oracle') 
{
	die("[Error]Oracle ÿ ڵ ġ  ʽϴ.\n  ߻翡 Ͽ ۾  ؾ մϴ.\n");	
}	// if()

$_start = getmicrotime();


$patch_query = array();

$patch_query[drop] = "
ALTER TABLE nmail_domain DROP d_quota_mbr_use ;
";

$patch_query[create] = "
CREATE TABLE nmail_spam_reject (
  m_no int(10) unsigned NOT NULL default '0',
  sr_email varchar(255) NOT NULL default '',
  sr_regdate datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (m_no, sr_email),
  INDEX (sr_regdate)
);

CREATE TABLE nmail_auto_filter
(
  as_no bigint(20) unsigned NOT NULL auto_increment,
  m_no int(10) unsigned NOT NULL default '0',
  as_name varchar(255),
  as_condition varchar(255),
  as_condition_text text,
  as_exec varchar(255),
  as_exec_text text,
  as_econdition varchar(255),
  as_econdition_text text,
  as_is_use enum('Y','N') default 'Y',
  as_sort tinyint unsigned NOT NULL default '0',
  PRIMARY KEY  (as_no),
  KEY as_m_no (m_no)
);

CREATE TABLE nmail_spam_allow (
  m_no int(10) unsigned NOT NULL default '0',
  sa_email varchar(255) NOT NULL default '',
  sa_regdate datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (m_no,sa_email),
  KEY sa_regdate (sa_regdate)
) ;

CREATE TABLE nmail_spam_config (
  m_no int(10) unsigned NOT NULL default '0',
  sc_addr_allow enum('Y','N') NOT NULL default 'Y',
  sc_fake_del enum('Y','N') NOT NULL default 'Y',
  sc_foreign_spam enum('Y','N') NOT NULL default 'N',
  sc_write_allow_add enum('Y','N') NOT NULL default 'Y',
  sc_from_subj_null_dell enum('Y','N') NOT NULL default 'N',
  sc_moddate datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (m_no)
) ;

CREATE TABLE nmail_member_group (
  mg_no int(10) unsigned NOT NULL auto_increment,
  d_no int(10) unsigned NOT NULL default '0',
  mg_name varchar(50) default NULL,
  mg_quota_default int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (mg_no),
  KEY mg_d_no (d_no)
);

CREATE TABLE nmail_auto_reply_loop_check (
  m_no int(10) unsigned NOT NULL default '0',
  ar_lc_email varchar(255) NOT NULL default '',
  ar_lc_regdate datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (m_no,ar_lc_email),
  KEY ar_lc_regdate (ar_lc_regdate)
) ;

CREATE TABLE nmail_white_ip (
  ip_ipaddr varchar(15) NOT NULL default '',
  ip_netmask varchar(15) NOT NULL default '',
  ip_regdate datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ip_ipaddr,ip_netmask),
  KEY ip_regdate (ip_regdate)
) ;
CREATE TABLE nmail_black_ip (
  ip_ipaddr varchar(15) NOT NULL default '',
  ip_netmask varchar(15) NOT NULL default '',
  ip_regdate datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ip_ipaddr,ip_netmask),
  KEY ip_regdate (ip_regdate)
) ;
CREATE TABLE nmail_relay_ip (
  ip_ipaddr varchar(15) NOT NULL default '',
  ip_netmask varchar(15) NOT NULL default '',
  ip_regdate datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ip_ipaddr,ip_netmask),
  KEY ip_regdate (ip_regdate)
) ;
";

$patch_query[add] = "
ALTER TABLE nmail_member ADD m_forwarding_type ENUM( 'N', 'Y', 'C' ) DEFAULT 'N' NOT NULL AFTER m_forwarding ;
ALTER TABLE nmail_member_field ADD d_no INT UNSIGNED DEFAULT '0' NOT NULL AFTER mbf_no ;
ALTER TABLE nmail_domain ADD d_quota_mbr_count INT UNSIGNED DEFAULT '100' NOT NULL AFTER d_quota_mbr_default ;
ALTER TABLE nmail_domain ADD d_memo TEXT;
ALTER TABLE nmail_domain ADD d_regdate DATETIME NOT NULL ;

ALTER TABLE nmail_mail_receive_check 
ADD mrcext_m_id VARCHAR( 50 ) default NULL,
ADD mrcext_d_name VARCHAR( 255 ) default NULL,
ADD mrcext_key VARCHAR( 10 ) default NULL,
ADD mrcext_ip VARCHAR( 15 ) default NULL;

ALTER TABLE nmail_member ADD mg_no INT UNSIGNED AFTER d_no ;
ALTER TABLE nmail_member ADD m_autoreply_isuse ENUM( 'Y', 'N' ) DEFAULT 'N' NOT NULL;
ALTER TABLE nmail_member ADD m_autoreply_subject VARCHAR( 255 );
ALTER TABLE nmail_member ADD m_autoreply_body TEXT;

ALTER TABLE nmail_domain ADD d_saveday TINYINT UNSIGNED DEFAULT '0'  AFTER d_quota_mbr_count ;
ALTER TABLE nmail_mail_box ADD mb_saveday TINYINT UNSIGNED DEFAULT '0' ;

ALTER TABLE nmail_member ADD m_suspend_start DATE;
ALTER TABLE nmail_member ADD m_suspend_end DATE;
ALTER TABLE nmail_member ADD m_use_start DATE;
ALTER TABLE nmail_member ADD m_use_end DATE;

ALTER TABLE nmail_domain ADD d_skin_main VARCHAR( 20 ) NOT NULL DEFAULT 'basic' AFTER d_saveday;
ALTER TABLE nmail_domain ADD d_skin_webmail VARCHAR( 20 ) NOT NULL DEFAULT 'basic' AFTER d_skin_main;
ALTER TABLE nmail_domain ADD d_skin_member VARCHAR( 20 ) NOT NULL DEFAULT 'basic' AFTER d_skin_webmail;
ALTER TABLE nmail_domain ADD d_skin_board VARCHAR( 20 ) NOT NULL DEFAULT 'basic' AFTER d_skin_member;

ALTER TABLE nmail_domain ADD d_shareaddr_isuse ENUM( 'Y', 'N' ) NOT NULL DEFAULT 'Y' AFTER d_skin_board ;
ALTER TABLE nmail_domain ADD d_shareaddr_reg ENUM( 'U', 'A' ) NOT NULL DEFAULT 'U' AFTER d_shareaddr_isuse ;
ALTER TABLE nmail_domain ADD d_sharediary_isuse ENUM( 'Y', 'N' ) NOT NULL DEFAULT 'Y' AFTER d_shareaddr_isuse ;
ALTER TABLE nmail_domain ADD d_sharediary_reg ENUM( 'U', 'A' ) NOT NULL DEFAULT 'U' AFTER d_sharediary_isuse ;

ALTER TABLE nmail_addr_group ADD d_no INT UNSIGNED NULL ;
ALTER TABLE nmail_addr ADD ad_no_share BIGINT unsigned;

ALTER TABLE nmail_diary ADD d_no INT UNSIGNED NULL ;
ALTER TABLE nmail_diary ADD di_no_share BIGINT UNSIGNED NULL ;

ALTER TABLE nmail_domain ADD d_quota_board INT UNSIGNED NOT NULL DEFAULT '2097152' AFTER d_quota_mbr_count ;
ALTER TABLE nmail_board ADD b_file_size INT UNSIGNED NOT NULL DEFAULT '0' AFTER b_file ;

ALTER TABLE nmail_member ADD m_cfg_new_mail_box VARCHAR( 255 ) NULL DEFAULT 'inbox|spam';
ALTER TABLE nmail_member ADD m_cfg_new_cnt TINYINT UNSIGNED NULL DEFAULT '7';
ALTER TABLE nmail_member ADD m_cfg_week_diray_cnt TINYINT UNSIGNED NULL DEFAULT '5';
ALTER TABLE nmail_member ADD m_cfg_from_name VARCHAR( 255 ) NULL ;
ALTER TABLE nmail_member ADD m_cfg_mail_list_cnt TINYINT UNSIGNED NULL DEFAULT '20';

ALTER TABLE nmail_domain ADD d_site_name VARCHAR( 255 ) NULL AFTER d_shareaddr_reg ;
ALTER TABLE nmail_domain ADD d_site_owner VARCHAR( 255 ) NULL AFTER d_site_name ;
ALTER TABLE nmail_domain ADD d_site_title VARCHAR( 255 )  NULL AFTER d_site_owner ;
ALTER TABLE nmail_domain ADD d_site_license TEXT NULL AFTER d_site_title ;
";

// index drop & add, update, delete, alter table change
$patch_query[normal] = "
ALTER TABLE nmail_member_field DROP INDEX mbf_name , ADD UNIQUE mbf_name ( d_no , mbf_name ) ;
UPDATE nmail_member_field SET mbf_issystem='N' WHERE mbf_name IN ('m_jumin', 'm_lostpwd_q', 'm_lostpwd_a');
ALTER TABLE nmail_domain CHANGE d_quota d_quota INT( 10 ) UNSIGNED DEFAULT '2097152' NOT NULL;
ALTER TABLE nmail_domain CHANGE d_quota_mbr_default d_quota_mbr_default INT( 10 ) UNSIGNED DEFAULT '20480' NOT NULL;
ALTER TABLE nmail_member_field CHANGE mbf_no mbf_no INT UNSIGNED NOT NULL AUTO_INCREMENT;
";

$patch_query[index_add] = "
ALTER TABLE nmail_member ADD INDEX mg_no ( mg_no ) ;
ALTER TABLE nmail_member ADD INDEX m_quota ( d_no , m_quota );
ALTER TABLE nmail_addr ADD INDEX ad_email ( adg_no , ad_email ) ;
ALTER TABLE nmail_mail_receive_check ADD INDEX m_no ( m_no ) ;
ALTER TABLE nmail_addr_group ADD INDEX m_no ( m_no ) ;
ALTER TABLE nmail_addr_group ADD INDEX d_no ( d_no ) ;
ALTER TABLE nmail_diary ADD INDEX d_no ( d_no ) ;
ALTER TABLE nmail_board ADD INDEX ba_no ( ba_no ) ;
ALTER TABLE nmail_board_comment ADD INDEX b_no ( b_no ) ;
ALTER TABLE nmail_board_admin ADD INDEX d_no ( d_no ) ;
";

$patch_query[index_drop] = "
ALTER TABLE nmail_mail_receive_check DROP INDEX mrc_no_2 ;
ALTER TABLE nmail_mail_receive_check DROP INDEX mrc_no ;
ALTER TABLE nmail_addr_group DROP INDEX adg_no ;
";




################################################################################


function table_exists($table)
{
	global $db;

	$q = "SHOW TABLES LIKE '$table'";
	$chk_objName = db_get_one($q);
	$table_exists = ($chk_objName) ? true : false;

	return $table_exists;
}	// function()


function field_exists($table, $name)
{
	global $db;

	$ti = $db->tableInfo($table);
	$field_exists = 0;
	for ($i=0; $i<sizeof($ti); $i++)
	{
		if ($ti[$i]['name'] == $name)
		{
			$field_exists = 1;
			break;
		}	// if()						
	}	// for()
	return $field_exists;
}	// function()

function index_exists($table, $name)
{
	global $db;

	$q = "SHOW INDEX FROM $table";
	$idxs = db_get_rows($q);

	$field_exists = 0;
	for ($i=0; $i<sizeof($idxs); $i++)
	{
		if ($idxs[$i]['key_name'] == $name)
		{
			$field_exists = 1;
			break;			
		}	// if()		
	}	// for()

	return $field_exists;
}	// function()

function get_query_name($query, $str)
{
	$pt = '/'.$str.'[ `\r\n\t]+([a-z0-9_\-]+)/i';
	preg_match($pt, $query, $mc);

	if (!$mc[1])
		die("[Error]ġ ۾   мϴ      Ͽϴ.=>\n".$query);

	return $mc[1];
}	// function()

$patch_query_key = array();
$patch_query_key = array_keys($patch_query);


for ($p=0; $p<sizeof($patch_query); $p++)
{
	$ar_query = array();
	$ar_query = explode(";", $patch_query[$patch_query_key[$p]]);
	for ($i=0; $i<sizeof($ar_query)-1; $i++)		//  ݷ(;)  ּ̰ų ̹Ƿ .
	{
		if (trim($ar_query[$i]) == '')
			continue;

		$isExecute = 1;

		if ($patch_query_key[$p] == 'normal')
		{
			$_table = '';
		} else 
		{
			$_table = get_query_name($ar_query[$i], "TABLE");
		}	// if()

		switch($patch_query_key[$p])
		{
			case "drop":
				$_field = get_query_name($ar_query[$i], "DROP");
				if (!field_exists($_table, $_field))
				{
					$isExecute = 0;
				}	// if()
				break;

			case "create":
				if (table_exists($_table))
				{
					$isExecute = 0;
				}	// if()
				break;

			case "add":
				$_field = get_query_name($ar_query[$i], "ADD");
				if (field_exists($_table, $_field))
				{
					$isExecute = 0;
				}	// if()
				break;

			case "index_add":
				$_field = get_query_name($ar_query[$i], "ADD INDEX");
				if (index_exists($_table, $_field))
				{
					$isExecute = 0;
				}	// if()
				break;

			case "index_drop":
				$_field = get_query_name($ar_query[$i], "DROP INDEX");
				if (!index_exists($_table, $_field))
				{
					$isExecute = 0;
				}	// if()
				break;

			default:		// normal
				// ߺص Ǵºκ
				break;
		}	// switch()

		if ($isExecute == 1)
		{
			db_query_debug($ar_query[$i]);
		}	// if()
	}	// for();
}	// for()

################################################################################
# nmail_mail_file_?_????
################################################################################

$q = "SHOW TABLES LIKE 'nmail_mail_file_%'";
$db->setFetchMode(DB_FETCHMODE_ORDERED);
$mft = db_get_rows($q);
$db->setFetchMode(DB_FETCHMODE_ASSOC);

function db_index_diff($table, $idxs, $key_name, $colmun_name_chk)
{
	$cols = array();
	for ($i=0; $i<sizeof($idxs['key_name']); $i++)
	{
		if ($idxs['key_name'][$i] == $key_name)
		{
			$cols[] = $idxs['column_name'][$i];
		}	// if()		
	}	// for()
	#vd($cols);

	if ($key_name == 'PRIMARY')
	{
		$idx_str = 'PRIMARY KEY';
	} else 
	{
		$idx_str = 'INDEX '.$key_name;
	}	// if()

	if (sizeof($cols) > 0)
	{
		$diff = array_diff($colmun_name_chk, $cols);
		$diff2 = array_diff($cols, $colmun_name_chk);
		if (sizeof($diff) > 0 || sizeof($diff2) > 0)
		{
			#echo "ε  ٸǷ  .";
			$q = "ALTER TABLE ".$table." DROP ".$idx_str.", ADD ".$idx_str." ( ".implode(',', $colmun_name_chk)." )";
			db_query_debug($q);
		}	// if()
	} else 
	{
		#echo "ε Ƿ ٷ .";
		$q = "ALTER TABLE ".$table." ADD ".$idx_str." ( ".implode(',', $colmun_name_chk)." )";
		db_query_debug($q);
	}	// if()
}	// function()


function db_query_debug($q)
{
	global $_start;
	if ($_SERVER['argv'][1] == 'DEBUG')
	{
		echo "    - Execute Query : " . trim($q)." (" . round((getmicrotime() - $_start),4) . "sec)\n";
		flush();
		db_query($q);				
	} else if ($_SERVER['argv'][1] == 'TEST')
	{
		echo "    - View Query : " . trim($q)." (" . round((getmicrotime() - $_start),4) . "sec)\n";
		flush();
	} else
	{
		db_query($q);				
	}	// if()	
}	// function()

for ($i=0; $i<sizeof($mft); $i++)
{
	#echo "\n".$mft[$i][0];

	// column
	if (!field_exists($mft[$i][0], 'mf_spam_point'))
	{
		$q = "ALTER TABLE ".$mft[$i][0]." ADD mf_spam_point FLOAT( 2 ) DEFAULT '0' NOT NULL";
		db_query_debug($q);
	}	// if()
	if (!field_exists($mft[$i][0], 'mf_is_userauth'))
	{
		$q = "ALTER TABLE ".$mft[$i][0]." ADD mf_is_userauth enum('Y', 'N')";
		db_query_debug($q);
	}	// if()
	if (!field_exists($mft[$i][0], 'mfext1'))
	{
		$q = "ALTER TABLE ".$mft[$i][0]." ADD mfext1 CHAR(1)";
		db_query_debug($q);
	}	// if()
	if (!field_exists($mft[$i][0], 'mfext2'))
	{
		$q = "ALTER TABLE ".$mft[$i][0]." ADD mfext2 VARCHAR( 20 )";
		db_query_debug($q);
	}	// if()
	if (!field_exists($mft[$i][0], 'mfext3'))
	{
		$q = "ALTER TABLE ".$mft[$i][0]." ADD mfext3 VARCHAR( 255 )";
		db_query_debug($q);
	}	// if()

	// index
	$q = "SHOW INDEX FROM ".$mft[$i][0];
	$idxs = db_get_rows($q, true);
	#vd($idxs['key_name']); vd($idxs['column_name']);
	db_index_diff($mft[$i][0], $idxs, 'PRIMARY', array('mf_no'));
	db_index_diff($mft[$i][0], $idxs, 'mf_no', array('m_no', 'mb_id', 'mf_no'));
	db_index_diff($mft[$i][0], $idxs, 'mf_filename', array('mf_filename'));
	db_index_diff($mft[$i][0], $idxs, 'mno_mbid', array('m_no', 'mb_id', 'mf_is_read', 'mf_filesize'));
	db_index_diff($mft[$i][0], $idxs, 'mf_arrival_date', array('m_no', 'mb_id', 'mf_arrival_date'));

	// [2006-11-01]   ׵  mf_filename  ƹ    ϵ .
		$q = "SELECT COUNT(*) FROM ".$mft[$i][0]." WHERE  mf_filename = '' AND mf_from = '' AND mf_to = '' AND mf_body = '' AND mf_attach_names = ''";
		$mf_error_cnt = db_get_one($q);
		if ($mf_error_cnt > 0)
		{
			$q = "DELETE FROM ".$mft[$i][0]." WHERE  mf_filename = '' AND mf_from = '' AND mf_to = '' AND mf_body = '' AND mf_attach_names = ''";
			db_query_debug($q);
		}	// if()	
}	// for()


// [2006-07-20] ڷ ÷   .
	$q = " 
		SELECT 
			ba_no, b_no, b_file
		FROM 
			".$TB['BOARD']."
		WHERE
			b_file != ''
			AND b_file_size = 0
		";
	$bf = db_get_rows($q);
	for ($i=0; $i<sizeof($bf); $i++)
	{
		$file = $UPLOAD_ROOT . "/" . $UPLOAD_DIR[BOARD] . "/" . $bf[$i]['ba_no'] . "/" . file_name_fix($bf[$i]['b_file'], $bf[$i]['b_no']);
		$fs = @filesize($file);
		if ($fs > 0)
		{
			$q = "UPDATE ".$TB['BOARD']." SET b_file_size='".$fs."' WHERE b_no='".$bf[$i]['b_no']."'";
			db_query($q);			
		}	// if()
	}	// for()


################################################################################


echo "\nġ ۾ ϷǾϴ. (" . round((getmicrotime() - $_start),4) . "sec)\n";


#require_once('include/global_end.php');
?>